
#ifndef EZYLIBH

#define EZYLIBH

#include <ezycom.h>
#include <stdio.h>

char    *AppendBackslash(char *Source);
int     ExistFile(char *Filename);
int     InitEzycom(char *FailReason,char *ExeCode = "");
int     FindParam(char *StrToFind);
char    *GetParam(char *StrToFind,char *Result);
void    pPasToC(char *Source, char *&Dest);
void    PasToC(char *Source, char *Dest);
char    *FindDataFilePath(char *Filename,char *Result);
int     FindMinusSlashParam(char *StrToFind);
char    *GetMinusSlashParam(char *StrToFind,char *Result);
char    *GetSystemPath();
longint FileSize(FILE *hStream);
longint FileSize(char *Filename);
long    UpdateCRC32(byte CurByte, long CurCRC);
char    *GetMsgAreaPath(word MsgBoard,char *MsgAreaPath,int FileType = 1);

void SetBitByte(byte Position,int Value,byte &ChangeByte);
void SetBitWord(byte Position,int Value,word &ChangeWord);

int CheckDate(word yy, word mm, word dd);                   // date1.cpp

// Convert Date to Ezycom Date format
word Date2Word(word yy, word mm, word dd);                  // date2.cpp

// Convert from Ezycom Date format to Day, Month and Year
int Word2Date(word Date, word &yy, word &mm, word &dd);     // date3.cpp

// Convert from Date to Packed Dos Format
unsigned long Date2Long(word year, word month, word day,
                        word hour, word min,   word sec);   // date4.cpp

// Unix format Date with Todays Time/Date
long TodayUnix();                                           // date5.cpp

// Unix format Date with number of days added to Todays Time/Date
long TodayUnixAddDays(longint Days);                        // date6.cpp

// Compare Unix and Dos Dates
//    -1 = Dos Date Less
//     0 = Equal
//     1 = Dos Date Greater
int  CompareDosUnixDate(long PackedDosDate,
                        unsigned long UnixDate);            // date7.cpp

// Convert Dos Packed Date to Year, Month, Day, Hour, Min, Sec
void Long2Date(long Date, word &Year, word &Month, word &Day,
                        word &Hour, word &Min, word &Sec);  // date8.cpp

word GetNextRead(FILE *hLastComb,word UserRecord,
                        word MsgBoard);                     // lastread.cpp
int  PutNextRead(FILE *hLastComb,word UserRecord,
                        word MsgBoard,word MsgNumber=1);    // lastread.cpp

// String functions
void ForceExtension(char *Path,char *Extension);            // str1.cpp
char *FirstWord(char *FirstWordStr,char *SourceStr);        // str2.cpp
char *TrimLead(char *S);                                    // str3.cpp
char *TrimTrail(char *S);                                   // str4.cpp
char *Trim(char *S);                                        // str5.cpp
char *RemoveBackslash(char *Source);                        // str6.cpp
char *ReplaceStr(char *StrSource,char *StrToFind,char *StrToReplace);
                                                            // str7.cpp

int OpenSystemLog(char *Filename);                          // flog.cpp
void WriteSystemLog(char *Description);                     // flog.cpp
void CloseSystemLog();                                      // flog.cpp

  // Opens and Retrieves the System Info Record
  // Also sets daily stats to 0 if they have changed 
int GetSysInfo(FILE *&hSysInfo,SysInfoRecord &SysInfo);      // updsys.cpp

  // Writes and Closes the System Info Record
void PutSysInfo(FILE *&hSysInfo,SysInfoRecord &SysInfo);     // updsys.cpp


extern char *SystemPath;
extern int  Node;
extern ConfigRecord   Config;
extern ConstantRecord Constant;
extern char *MsgPath;
extern char *UserBasePath;
extern char *MaintLog;
extern char ShortMonths[12][4];

#ifndef TRUE
	#define TRUE 1
#endif

#ifndef FALSE
	#define FALSE 0
#endif

#ifdef __OS2__
  #define WILDCARD "*"
#else
  #define WILDCARD "*.*"
#endif

#ifdef __OS2__
  #define OSTYPE "OS2"
#else
  #ifdef __WIN32__
    #ifdef __DPMI32__
      #define OSTYPE "DPMI32"
    #else
      #define OSTYPE "WIN 95/NT"
    #endif
  #else
    #define OSTYPE "DOS16"
  #endif
#endif


#endif
